package array;
import java.util.*;
import java.io.*;

/**
 * 题目描述
 *
 * 给定一个整数数组 Array，请计算该数组在每个指定区间内元素的总和。
 *
 * 输入描述
 *
 * 第一行输入为整数数组 Array 的长度 n，接下来 n 行，每行一个整数，表示数组的元素。随后的输入为需要计算总和的区间下标：a，b （b > = a），直至文件结束。
 * 输入示例：
 * 5
 * 1
 * 2
 * 3
 * 4
 * 5
 * 0 1
 * 1 3
 *输出：
 * 3
 * 9
 * 输出每个指定区间内元素的总和。
 */
public class RangeSum {
    public static void main(String[] args) throws IOException {
        // 快速 IO
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter out = new PrintWriter(System.out);
        String line;

        // 1）读数组长度
        line = br.readLine();
        if (line == null) return;
        int n = Integer.parseInt(line.trim());

        // 2）读数组元素并构造前缀和
        long[] prefix = new long[n + 1];
        for (int i = 0; i < n; i++) {
            line = br.readLine();
            if (line == null) throw new IOException("Unexpected EOF when reading array");
            prefix[i + 1] = prefix[i] + Long.parseLong(line.trim());
        }

        // 3）依次读查询直到 EOF
        //    每行两个整数 a, b (0 ≤ a ≤ b < n)
        while ((line = br.readLine()) != null) {
            line = line.trim();
            if (line.isEmpty()) continue;
            StringTokenizer st = new StringTokenizer(line);
            int a = Integer.parseInt(st.nextToken());
            int b = Integer.parseInt(st.nextToken());

            // 区间和 = prefix[b+1] - prefix[a]
            long sum = prefix[b + 1] - prefix[a];
            out.println(sum);
        }

        out.flush();
    }
}
