package backtrack;

import java.util.ArrayList;
import java.util.List;

/**
 * 题目：216. 组合总和 III (combinationSum3)
 * 描述：找出所有相加之和为 n 的 k 个数的组合，且满足下列条件：
 * 只使用数字1到9
 * 每个数字 最多使用一次
 * 返回 所有可能的有效组合的列表 。该列表不能包含相同的组合两次，组合可以以任何顺序返回。
 *
 * 示例 1：
 输入: k = 3, n = 7
 输出: [[1,2,4]]
 解释:
 1 + 2 + 4 = 7
 没有其他符合的组合了。

 * 链接：https://leetcode.cn/problems/combination-sum-iii/
 */
public class CombinationSum3 {
    void dfs(int n,int k,int used,List<List<Integer>>res,List<Integer>path,int cursum,int begin){
        if(used==k){
            if(n==cursum)
                res.add(new ArrayList<>(path));
        }else{
            for (int i = begin; i <= 9; i++) {
                path.add(i);
                used++;
                cursum+=i;
                dfs(n,k,used,res,path,cursum,i+1);
                cursum-=i;
                used--;
                path.remove(path.size()-1);
            }
        }
    }
    public List<List<Integer>> combinationSum3(int k, int n) {
        List<List<Integer>>res=new ArrayList<>();
        List<Integer>path=new ArrayList<>();
        dfs(n,k,0,res,path,0,1);
        return res;
    }
}
