package greedy;
/**
 * 题目： 738. 单调递增的数字 (monotoneIncreasingDigits)
 * 描述：当且仅当每个相邻位数上的数字 x 和 y 满足 x <= y 时，我们称这个整数是单调递增的。
 *
 * 给定一个整数 n ，返回 小于或等于 n 的最大数字，且数字呈 单调递增 。

 * 示例 1：
 输入: n =  2332
 输出: 2299

 * 链接：https://leetcode.cn/problems/monotone-increasing-digits/
 */
//不会
public class MonotoneIncreasingDigits {
    /**
     * 一旦发现某一位数字比右边一位大，就必须在这一位或更靠左的一位上“借位”——将该位数字减一，而后面的所有位都置为 9，以保证单调递增同时又尽可能大。
     从右往左 对每一对相邻位做检查，
     只要发现 d[i-1] > d[i]，就把 d[i-1]--，并把标记 mark = i（表示从这里开始以后都要变成 9），
     整个遍历不要 break，而是继续往左走，处理可能连锁的多次借位，
     最后把 mark 及以后的所有位都设成 '9'。
     * @param n
     * @return
     */
    public int monotoneIncreasingDigits(int n) {
        char[] d = String.valueOf(n).toCharArray();
        int mark = d.length;
        // 1) 从右往左，遇到下降就借位并记录位置
        for (int i = d.length - 1; i > 0; --i) {
            if (d[i-1] > d[i]) {
                d[i-1]--;        // 借位
                mark = i;        // 标记后续全改成 9
            }
        }
        // 2) 从 mark 到末尾全设为 '9'
        for (int i = mark; i < d.length; ++i) {
            d[i] = '9';
        }
        // 3) 拼回整数返回
        return Integer.parseInt(new String(d));
    }

}
