package stack;

import java.util.ArrayDeque;
import java.util.Deque;

/**
 * 题目： 1047. 删除字符串中的所有相邻重复项 ( removeDuplicates)
 * 描述：给出由小写字母组成的字符串 s，重复项删除操作会选择两个相邻且相同的字母，并删除它们。
 * 在 s 上反复执行重复项删除操作，直到无法继续删除。
 * 在完成所有重复项删除操作后返回最终的字符串。答案保证唯一。
 *
 * 示例 1：
 输入："abbaca"
 输出："ca"
 解释：例如，在 "abbaca" 中，我们可以删除 "bb" 由于两字母相邻且相同，这是此时唯一可以执行删除操作的重复项。
 之后我们得到字符串 "aaca"，其中又只有 "aa" 可以执行重复项删除操作，所以最后的字符串为 "ca"。

 * 链接：https://leetcode.cn/problems/remove-all-adjacent-duplicates-in-string/
 */
public class RemoveDuplicates {
    public String removeDuplicates(String s) {
        Deque<Character>stack=new ArrayDeque<>();
        stack.push(s.charAt(0));
        for (int i = 1; i < s.length(); i++) {
            if(!stack.isEmpty()) {
                char top = stack.peek();
                if (top == s.charAt(i))
                    stack.pop();
                else
                    stack.push(s.charAt(i));
            }
            else
                stack.push(s.charAt(i));
        }
        StringBuilder sb=new StringBuilder();
        while (!stack.isEmpty()){
            sb.insert(0,stack.pop());
        }
        return sb.toString();
    }
}
