package string;
/**
 * 题目： 541. 反转字符串 II (reverseStr)
 * 描述：给定一个字符串 s 和一个整数 k，从字符串开头算起，每计数至 2k 个字符，就反转这 2k 字符中的前 k 个字符。
 *
 * 如果剩余字符少于 k 个，则将剩余字符全部反转。
 * 如果剩余字符小于 2k 但大于或等于 k 个，则反转前 k 个字符，其余字符保持原样。
 *
 * 示例 1：
 输入：s = "abcdefg", k = 2
 输出："bacdfeg"

 * 链接：https://leetcode.cn/problems/reverse-string-ii/
 */
public class ReverseStr {
    public String reverseStr(String s, int k) {
        if (s == null || s.length() <= 1 || k <= 1) return s;

        char[] ch = s.toCharArray();
        int n = ch.length;

        // i 每次跳过 2k，指向每段的起点
        for (int i = 0; i < n; i += 2 * k) {
            // 计算本次需要翻转的区间 [i, right]
            int left = i;
            int right = Math.min(i + k - 1, n - 1);
            reverse(ch, left, right);
        }
        return new String(ch);
    }

    /** 原地翻转 ch[l..r] */
    private void reverse(char[] ch, int l, int r) {
        while (l < r) {
            char tmp = ch[l];
            ch[l] = ch[r];
            ch[r] = tmp;
            l++;
            r--;
        }
    }
}
