package tree;
/**
 * 题目： 654. 最大二叉树 (constructMaximumBinaryTree )
 * 描述：给定一个不重复的整数数组 nums 。 最大二叉树 可以用下面的算法从 nums 递归地构建:
 *
 * 创建一个根节点，其值为 nums 中的最大值。
 * 递归地在最大值 左边 的 子数组前缀上 构建左子树。
 * 递归地在最大值 右边 的 子数组后缀上 构建右子树。
 * 返回 nums 构建的 最大二叉树 。
 *
 * 示例 1：
 输入：nums = [3,2,1,6,0,5]
 输出：[6,3,5,null,2,0,null,null,1]
 解释：递归调用如下所示：
 - [3,2,1,6,0,5] 中的最大值是 6 ，左边部分是 [3,2,1] ，右边部分是 [0,5] 。
 - [3,2,1] 中的最大值是 3 ，左边部分是 [] ，右边部分是 [2,1] 。
 - 空数组，无子节点。
 - [2,1] 中的最大值是 2 ，左边部分是 [] ，右边部分是 [1] 。
 - 空数组，无子节点。
 - 只有一个元素，所以子节点是一个值为 1 的节点。
 - [0,5] 中的最大值是 5 ，左边部分是 [0] ，右边部分是 [] 。
 - 只有一个元素，所以子节点是一个值为 0 的节点。
 - 空数组，无子节点。

 * 链接：https://leetcode.cn/problems/maximum-binary-tree/
 */
public class ConstructMaximumBinaryTree {
    int findmax(int[] nums,int l, int r){
        int MaxIndex=l;
        for (int i = l+1; i <= r; i++) {
            if(nums[MaxIndex]<nums[i])
                MaxIndex=i;
        }
        return MaxIndex;
    }
    TreeNode dfs(int[] nums,int l,int r){
        if(l>r)return null;
        int maxindex=findmax(nums,l,r);
        TreeNode root=new TreeNode(nums[maxindex]);
        root.left=dfs(nums,l,maxindex-1);
        root.right=dfs(nums,maxindex+1,r);
        return root;
    }
    public TreeNode constructMaximumBinaryTree(int[] nums) {
        return dfs(nums,0,nums.length-1);
    }
}
