package tree;

/**
 * 题目：538. 把二叉搜索树转换为累加树 (convertBST)
 * 描述：给出二叉 搜索 树的根节点，该树的节点值各不相同，请你将其转换为累加树（Greater Sum Tree），使每个节点 node 的新值等于原树中大于或等于 node.val 的值之和。
 * 提醒一下，二叉搜索树满足下列约束条件：
 * 节点的左子树仅包含键 小于 节点键的节点。
 * 节点的右子树仅包含键 大于 节点键的节点。
 * 左右子树也必须是二叉搜索树。
 *
 * 示例 1：
 输入：[4,1,6,0,2,5,7,null,null,null,3,null,null,null,8]
 输出：[30,36,21,36,35,26,15,null,null,null,33,null,null,null,8]

 * 链接：https://leetcode.cn/problems/convert-bst-to-greater-tree/
 */
//反向中序遍历，得到降序数组
public class ConvertBST {
    // 全局累加和，用于记录当前“比本节点值大的所有节点之和”
    private int sum = 0;

    // 对给定的 BST 做逆序中序遍历，更新节点值
    private void reverseInorder(TreeNode node) {
        if (node == null) return;

        // 1. 先遍历右子树（右子树节点值都比 node.val 大）
        reverseInorder(node.right);

        // 2. 处理当前节点：sum 里存的是“之前访问过的所有节点（即比它值更大的那些节点）的累加值”
        sum += node.val;
        node.val = sum;

        // 3. 再遍历左子树（左子树节点值都比 node.val 小）
        reverseInorder(node.left);
    }

    public TreeNode convertBST(TreeNode root) {
        reverseInorder(root);
        return root;
    }
}
