package tree;

import java.util.ArrayList;
import java.util.List;
/**
 * 题目：501. 二叉搜索树中的众数 (findMode)
 * 描述：给你一个含重复值的二叉搜索树（BST）的根节点 root ，找出并返回 BST 中的所有 众数（即，出现频率最高的元素）。
 *
 * 如果树中有不止一个众数，可以按 任意顺序 返回。
 *
 * 假定 BST 满足如下定义：
 *
 * 结点左子树中所含节点的值 小于等于 当前节点的值
 * 结点右子树中所含节点的值 大于等于 当前节点的值
 * 左子树和右子树都是二叉搜索树
 *
 * 示例 1：
 输入：root = [1,null,2,2]
 输出：[2]

 * 链接：https://leetcode.cn/problems/find-mode-in-binary-search-tree/
 */
public class FindMode {
    private int maxCount = 0;        // 当前已知的最大频率
    private int count = 0;           // 正在统计的当前节点值的出现次数
    private TreeNode pre = null;     // 中序遍历时，前一个被访问的节点
    private List<Integer> result = new ArrayList<>(); // 存放众数的列表

    public int[] findMode(TreeNode root) {
        // 初始化（如果同一个 Solution 实例可能被重复调用，需要做清空）
        maxCount = 0;
        count = 0;
        pre = null;
        result.clear();

        // 递归中序遍历
        inorder(root);

        // 把 List<Integer> 转成 int[]
        int[] modes = new int[result.size()];
        for (int i = 0; i < result.size(); i++) {
            modes[i] = result.get(i);
        }
        return modes;
    }

    // 递归中序遍历
    private void inorder(TreeNode node) {
        if (node == null) return;

        // 先遍历左子树
        inorder(node.left);

        // “访问”当前节点时，更新 count / maxCount / result
        if (pre == null) {
            // 第一个被访问的节点
            count = 1;
        } else if (pre.val == node.val) {
            // 与前一个节点值相同，就累加
            count++;
        } else {
            // 值变了，重置计数为 1
            count = 1;
        }
        pre = node; // 记录“上一个”节点

        // 根据当前 count 和 maxCount 更新结果
        if (count == maxCount) {
            result.add(node.val);
        } else if (count > maxCount) {
            maxCount = count;
            result.clear();
            result.add(node.val);
        }

        // 再遍历右子树
        inorder(node.right);
    }
}
