package tree;
/**
 * 题目：235. 二叉搜索树的最近公共祖先 (LowestCommonAncestor)
 * 描述：给定一个二叉搜索树, 找到该树中两个指定节点的最近公共祖先。
 *
 * 百度百科中最近公共祖先的定义为：“对于有根树 T 的两个结点 p、q，最近公共祖先表示为一个结点 x，满足 x 是 p、q 的祖先且 x 的深度尽可能大（一个节点也可以是它自己的祖先）。”
 *
 * 例如，给定如下二叉搜索树:  root = [6,2,8,0,4,7,9,null,null,3,5]
 *
 * 示例 1：
 输入: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 8
 输出: 6
 解释: 节点 2 和节点 8 的最近公共祖先是 6。

 * 链接：https://leetcode.cn/problems/lowest-common-ancestor-of-a-binary-search-tree/
 */
public class LowestCommonAncestor2 {
    public TreeNode lowestCommonAncestor(TreeNode root, TreeNode p, TreeNode q) {
        // 如果 root 为 null（空树）或者恰好碰到 p/q 中的一个，就直接返回 root
        if (root == null) {
            return null;
        }
        // 由于是 BST，可利用大小关系快速定位
        if (root.val > p.val && root.val > q.val) {
            // p 和 q 都比 root 小，LCA 在左子树
            return lowestCommonAncestor(root.left, p, q);
        } else if (root.val < p.val && root.val < q.val) {
            // p 和 q 都比 root 大，LCA 在右子树
            return lowestCommonAncestor(root.right, p, q);
        } else {
            // 否则，root 已经是 p、q 的分叉点（或者 root 等于 p 或 q），就是 LCA
            return root;
        }
    }
}
