package tree;
/**
 * 题目： 404. 左叶子之和 ( sumOfLeftLeaves)
 * 描述：给定二叉树的根节点 root ，返回所有左叶子之和。
 *
 * 示例 1：
 输入: root = [3,9,20,null,null,15,7]
 输出: 24
 解释: 在这个二叉树中，有两个左叶子，分别是 9 和 15，所以返回 24

 * 链接：https://leetcode.cn/problems/sum-of-left-leaves/
 */
public class SumOfLeftLeaves {
    private int total = 0;

    public int sumOfLeftLeaves(TreeNode root) {
        total = 0;
        dfs(root);
        return total;
    }

    private void dfs(TreeNode node) {
        if (node == null) return;
        // 如果 node 的左孩子是叶子，累加
        if (node.left != null
                && node.left.left == null
                && node.left.right == null) {
            total += node.left.val;
        }
        // 继续遍历左右子树
        dfs(node.left);
        dfs(node.right);
    }
    public int sumOfLeftLeaves2(TreeNode root) {
        if (root == null) return 0;
        int sum = 0;
        // 如果左子节点是叶子，直接加上它的值
        if (root.left != null
                && root.left.left == null
                && root.left.right == null) {
            sum += root.left.val;
        } else {
            // 否则，递归累加左子树里的左叶子
            sum += sumOfLeftLeaves(root.left);
        }
        // 右子树也要继续找它的“左叶子”
        sum += sumOfLeftLeaves(root.right);
        return sum;
    }
}
