package tree;
/**
 * 题目：669. 修剪二叉搜索树 (trimBST)
 * 描述：给你二叉搜索树的根节点 root ，同时给定最小边界low 和最大边界 high。通过修剪二叉搜索树，使得所有节点的值在[low, high]中。
 * 修剪树 不应该 改变保留在树中的元素的相对结构 (即，如果没有被移除，原有的父代子代关系都应当保留)。 可以证明，存在 唯一的答案 。
 * 所以结果应当返回修剪好的二叉搜索树的新的根节点。注意，根节点可能会根据给定的边界发生改变。
 *
 * 示例 1：
 输入：root = [1,0,2], low = 1, high = 2
 输出：[1,null,2]

 * 链接：https://leetcode.cn/problems/trim-a-binary-search-tree/
 */
//不会
public class TrimBST {
    public TreeNode trimBST(TreeNode root, int low, int high) {
        if (root == null) {
            return null;
        }

        // 情况一：当前节点值过小，左子树都小于它 => 整个左子树都可丢弃
        if (root.val < low) {
            return trimBST(root.right, low, high);
        }

        // 情况二：当前节点值过大，右子树都大于它 => 整个右子树都可丢弃
        if (root.val > high) {
            return trimBST(root.left, low, high);
        }

        // 情况三：当前节点值在区间 [low, high] 内，需要保留，
        // 但左右子树仍需递归修剪
        root.left  = trimBST(root.left,  low, high);
        root.right = trimBST(root.right, low, high);
        return root;
    }
}
